#pragma warning( disable : 4996 ) 

 
#include <cstdlib>
#include <vector>
#include <iostream>
#include <string>
#include "G2D.h"
using namespace std;

// touche P   : mets en pause
// touche ESC : ferme la fentre et quitte le jeu


#pragma warning( disable : 4996 ) 


#include <cstdlib>
#include <vector>
#include <iostream>
#include <string>
#include "G2D.h"


using namespace std;


struct Xenon
{
	V2 pos;
	V2 size;
	int IdSpriteNormal;
	int IdSpriteLeft;
	int IdSpriteRight;

	Xenon()
	{
		pos = V2(300, 100);
		size = V2(32, 27);
	}

	void InitTextures()
	{
		IdSpriteNormal = G2D::ExtractTextureFromPNG(".//assets//xenon.png", Transparency::UpperLeft);
		IdSpriteLeft   = G2D::ExtractTextureFromPNG(".//assets//xenonLeft.png", Transparency::UpperRight);
		IdSpriteRight  = G2D::ExtractTextureFromPNG(".//assets//xenonRight.png", Transparency::UpperRight);
		int zoom = 3;
		size = size * zoom;
	}
};
 
   

///////////////////////////////////////////////////////////////////////////////
//
//    Donnes du jeu - structure instancie dans le main

struct GameData
{
	int HeighPix = 800;   // hauteur de la fentre d'application
	int WidthPix = 600;   // largeur de la fentre d'application

	Xenon X;

	GameData() {}
};

 
///////////////////////////////////////////////////////////////////////////////
//
// 
//     fonction de rendu - reoit en paramtre les donnes du jeu par rfrence



void Render(const GameData& G)
{
	G2D::clearScreen(Color::Black);

	G2D::drawStringFontMono(V2(100, 300), "Use arrow key to move", 20, 3, Color::Red);

	int idsprite = G.X.IdSpriteNormal;
	if (G2D::isKeyPressed(Key::LEFT))  idsprite = G.X.IdSpriteLeft;
	if (G2D::isKeyPressed(Key::RIGHT)) idsprite = G.X.IdSpriteRight;
	G2D::drawRectWithTexture(idsprite, G.X.pos, G.X.size);

	G2D::Show();
}




	
///////////////////////////////////////////////////////////////////////////////
//
//
//      Gestion de la logique du jeu - reoit en paramtre les donnes du jeu par rfrence



void Logic(GameData & G) // appel 20 fois par seconde
{
	int speed = 2;
	if (G2D::isKeyPressed(Key::LEFT))  G.X.pos.x -= speed;
	if (G2D::isKeyPressed(Key::RIGHT)) G.X.pos.x += speed;
	if (G2D::isKeyPressed(Key::UP))  G.X.pos.y += speed;
	if (G2D::isKeyPressed(Key::DOWN)) G.X.pos.y -= speed;
}
 

///////////////////////////////////////////////////////////////////////////////
//
//
//        Dmarrage de l'application



int main(int argc, char* argv[])
{
	GameData G;   // instanciation de l'unique objet GameData qui sera pass aux fonctions render et logic
	

	// cre la fentre de l'application
	G2D::initWindow(V2(G.WidthPix, G.HeighPix), V2(20, 20), string("G2D DEMO"));

	// nombre de fois o la fonction Logic est appele par seconde
	int callToLogicPerSec = 50;  

	// lance l'application en spcifiant les deux fonctions utilises et l'instance de GameData
	
	G.X.InitTextures();

	G2D::Run(Logic, Render, G, callToLogicPerSec,true);

	// aucun code ici
}





